(*
	=================================================
    Date: Sat, 12 Feb 2000 17:10:26 +0900
    From: Takuo Nakamura <nakamuri@asahi.email.ne.jp>
    Subject: [Delphi:46274] Re: vZ
	=================================================
    Date: Sat, 12 Feb 2000 17:22:24 +0900
    From: Takuo Nakamura <nakamuri@asahi.email.ne.jp>
    Subject: [Delphi:46275] Re: vZ
	=================================================
	܂܂...
	=================================================
*)
unit ExpParser;

interface

function	Calculate(Text: string): Extended;
//function ExpressionParser(Text: string): Extended;

implementation

uses
    SysUtils, Math, Dialogs;

type
    TSymbolID = (LPAR, RPAR, PLUS, MINUS, MULTI, DIVIDE, NUMBER, ENDOFTEXT);

    TSymbol = record
        ID      : TSymbolID;
        Value   : Extended;
    end;

    ESymbolError = class(Exception);
    ESyntaxError = class(Exception);

function	Calculate(Text: string): Extended;
//function  ExpressionParser(Text: string): Extended;
var
	cp      : Integer;
    Sym     : TSymbol;
    TextLength  : Integer;
    cc      : Char;
    FractionLength: Integer;
    IsEOT   : Boolean;

    function IsBlank(c: Char): Boolean;
    begin
        Result := c in [#13, #10, #09, ' '];
    end;

    procedure GetChar;
    begin
        if cp > TextLength then
        begin
            IsEOT := True
        end else
        begin
            cc := Text[cp];
            Inc(cp);
        end;
    end;

    procedure SkipBlank;
    begin
        while IsBlank(cc) and not IsEOT do
        begin
            GetChar;
        end;
    end;

    //Lexical Analyzer
    procedure GetSym;
    var
        Value: Extended;
    begin
        SkipBlank;
        if IsEOT then
        begin
            Sym.ID := ENDOFTEXT;
            Exit;
        end;

        // lH
        if (cc in ['0'..'9']) and not IsEOT then
        begin
            Sym.ID := NUMBER;
            Value := StrToInt(cc);
            GetChar;
            while (cc in ['0'..'9']) and not IsEOT do
            begin
                Value := Value * 10 + StrToInt(cc);
                GetChar;
            end;
            if cc = '.' then
            begin
                GetChar;
                FractionLength := 0;
                while (cc in ['0'..'9']) and not IsEOT do
                begin
                    Value := Value * 10 + StrToInt(cc);
                    GetChar;
                    Inc(FractionLength);
                end;
                Value := Value / Power(10, FractionLength);
            end;
            Sym.Value := Value;
        end else
        begin
            // ̃V{
            case cc of
            '(': Sym.ID := LPAR;
            ')': Sym.ID := RPAR;
            '+': Sym.ID := PLUS;
            '-': Sym.ID := MINUS;
            '*': Sym.ID := MULTI;
            '/': Sym.ID := DIVIDE;
            else
	            raise ESymbolError.Create('Symbol Error');
            end;
            GetChar;
        end;
    end;

    procedure SyntaxError;
    begin
        raise ESyntaxError.Create('SyntaxError');
    end;

    function Expression: Extended; forward;

    // l or () ̃p[XƌvZ
    function Factor: Extended;
    begin
        if Sym.ID = NUMBER then
        begin
            Result := Sym.Value; GetSym; Exit;
        end else
        if Sym.ID = LPAR then
        begin
            GetSym;
            Result := Expression;
            if Sym.ID = RPAR then
            begin
                GetSym ;
                Exit;
            end else
            begin
                SyntaxError;
            end;
        end else
        begin
            SyntaxError;
        end;
    end;

    //  ̃p[XƌvZ
    function Term: Extended;
    begin
        Result := Factor;
        while (Sym.ID = MULTI) or (Sym.ID = DIVIDE) do
        begin
            if Sym.ID = MULTI then
            begin
                GetSym;
                Result := Result * Factor;
            end else begin
                GetSym;
                Result := Result / Factor;
            end;
        end;
    end;

    // ̃p[XƌvZ
    function Expression: Extended;
    begin
        if Sym.ID = PLUS then
        begin
            GetSym;
            Result := Term;
        end else
        if Sym.ID = MINUS then
        begin
            GetSym;
            Result := - Term;
        end else
        begin
            Result := Term;
        end;

        while (Sym.ID = PLUS) or (Sym.ID = MINUS) do
        begin
            if Sym.ID = PLUS then
            begin
                GetSym;
                Result := Result + Term;
            end else
            begin
                GetSym;
                Result := Result - Term;
            end;
        end;
    end;

    function Parser: Extended;
    begin
        Result := Expression;
        if Sym.ID <> ENDOFTEXT then
        begin
            SyntaxError;
        end;
    end;

begin
    TextLength  := Length(Text);
    cp          := 1;
    IsEOT       := False;
    GetChar;
    GetSym;
    Result      := Parser;
end;

end.

