unit Main;

interface

uses
  Windows, Forms, Dialogs, Base, Classes, Controls, ExtCtrls, StdCtrls,
  Graphics, ComCtrls;

type
  TMainForm = class(TBaseForm)
    pnlHeader: TPanel;
    imgLogo: TImage;
    Panel1: TPanel;
    tab: TTabControl;
    Split: TSplitter;
    memIn: TMemo;
    memOut: TMemo;
    procedure memInChange(Sender: TObject);
    procedure tabChange(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure memInKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
	ResultVal	: Extended;

	procedure	VerticalPane();
	procedure	HorizontalPane();

	procedure	SaveSetting();
	procedure	LoadSetting();

	procedure 	AppShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
  public
	procedure	DroppedAction(); override;
  end;

var
  MainForm: TMainForm;

implementation

uses
	Messages, SysUtils, iCalc;

var
	DataFile: string;

{$R *.dfm}

(*
	#####################################################

    S

	#####################################################
*)

(* RXgN^ *)
procedure TMainForm.FormCreate(Sender: TObject);
begin
	inherited;
	//ݒǂݍ
	LoadSetting();
	//^uݒ
    tabChange(tab);
	//qgJX^}CY
	Application.OnShowHint := AppShowHint;
	Screen.HintFont.Assign(Self.Font);
end;

(* fXgN^ *)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
	//ݒۑ
	SaveSetting();
	inherited;
end;

(* ݒۑ *)
procedure	TMainForm.SaveSetting();
begin
	SaveIniInteger('TabIndex', tab.TabIndex);
    memIn.Lines.SaveToFile(DataFile);
end;

(* ݒǂݍ *)
procedure	TMainForm.LoadSetting();
begin
	tab.TabIndex := LoadIniInteger('TabIndex', tab.TabIndex);
    if FileExists(DataFile) then memIn.Lines.LoadFromFile(DataFile);
end;

(*
	#####################################################

    CAEg

	#####################################################
*)

(* yC㉺ *)
procedure	TMainForm.VerticalPane();
begin
    memOut.Align := alBottom;
    Split.Align := alBottom;
end;

(* yCE *)
procedure	TMainForm.HorizontalPane();
begin
    memOut.Align := alRight;
    Split.Align := alRight;
end;

(* ^uIꂽ烌CAEgω *)
procedure TMainForm.tabChange(Sender: TObject);
begin
	case tab.TabIndex of
	0:	HorizontalPane();
    1:	VerticalPane();
	end;
end;

(*
	#####################################################

    ͕⏕

	#####################################################
*)

(* t@Chbvꂽ1Ԗڂ̃t@Cǂݍ *)
procedure	TMainForm.DroppedAction();
begin
	if DropFileList.Count > 0 then
    begin
		memIn.Lines.LoadFromFile(DropFileList[0]);
    end;
end;

(* ͗pωČvZ *)
procedure TMainForm.memInChange(Sender: TObject);
begin
	//vZ
	ResultVal := CalcStrings(memIn.Lines, memOut.Lines);
	//o͌ʂ͂ݏo邱Ƃz肵
    memOut.SelStart := Length(memOut.Text);
	//IɈԉɃXN[
    memOut.Perform(EM_SCROLLCARET, 0, 0);
end;

(* L[Ƃ *)
procedure TMainForm.memInKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	//[CTRL]{^Ă鎞
	if (ssCtrl in Shift) then
    begin
        case Key of
		//uAvőSI
        Ord('A') : TMemo(Sender).SelectAll;
		//uRvŌʂ͑ɃRs[
        Ord('R') : memIn.Text := FloatToStr(ResultVal);
		//uDELETEvœ̓NA
        VK_DELETE: memIn.Text := '';
        end;
    end;
end;

(*
	#####################################################

    tH[JXړ

	#####################################################
*)

(* }EXzC[Œ̃Rg[ɃtH[JXړ *)
procedure TMainForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
	Ctrl: TWinControl;
begin
	Ctrl := FindVCLWindow(MousePos);
    Ctrl.SetFocus();
end;

(* tH[ŃL[ꂽ *)
procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	inherited;
	//̓ɋtH[JXړ(ł1ڂ͓)
    memIn.SetFocus();
end;

(*
	#####################################################

    ̑

	#####################################################
*)

const
    H_00 = '+-/*()gpł܂B';
	H_01 = '[CTRL]+[A]őSI܂B';
	H_02 = '[CTRL]+[R]œ͑̃eLXgvZʂŒu܂B';
    H_03 = '[CTRL]+[DELETE]œ͑̃eLXgNA܂B';
    H_04 = 't@ChbOhbvĂǂݍ߂܂B';
    H_05 = 'NɃt@ChbOhbvĂǂݍ߂܂B';
    H_06 = '[ESC]ŏI܂B';
    H_07 = 'I̓͑̃eLXgNɓǂݍ݂܂B';
var
	HintStrs: array[0..7] of string = (H_00,H_01,H_02,H_03,H_04,H_05,H_06,H_07);

(* qg\JX^}CY *)
procedure 	TMainForm.AppShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
begin
    if HintInfo.HintControl = imgLogo then
    begin
        HintStr := HintStrs[Random(3)];
        HintInfo.ReshowTimeout := 3000;    // qgXVԊu(~b)
    end;
end;

initialization

	DataFile := ChangeFileExt(Application.ExeName, '.dat');

end.
